#include "DHT.h"
#include <LiquidCrystal.h>
DHT _dht1(7, DHT11);

LiquidCrystal _lcd1(12, 11, 5, 4, 3, 2);
int _dispTempLength1=0;
boolean _isNeedClearDisp1;

int _disp1oldLength = 0;
unsigned long _dht1Tti = 0UL;
float _dht1t = 0.00;
float _dht1h = 0.00;
int _disp2oldLength = 0;
void setup()
{
_lcd1.begin(16, 2);
_dht1.begin();
}
void loop()
{if(_isTimer(_dht1Tti, 1000)) {
_dht1Tti = millis(); 
float tempDht7;
 tempDht7 = _dht1.readTemperature();
if (!(isnan(tempDht7))){_dht1t=tempDht7; }
}if (_isNeedClearDisp1) {_lcd1.clear(); _isNeedClearDisp1= 0;}




if (1) {
_dispTempLength1 = ((((( _floatToStringWitRaz(( (analogRead (5)))*(0.0049),2))) + (String(" V")) + (String("  T ")) + (( _floatToStringWitRaz(_dht1t,2)))))).length();
if (_disp2oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp2oldLength = _dispTempLength1;
_lcd1.setCursor(0, 0);
_lcd1.print((((( _floatToStringWitRaz(( (analogRead (5)))*(0.0049),2))) + (String(" V")) + (String("  T ")) + (( _floatToStringWitRaz(_dht1t,2))))));
} else {
if (_disp2oldLength > 0) {_isNeedClearDisp1 = 1; _disp2oldLength = 0;} 
}
if (1) {
_dispTempLength1 = ((((String("T ")) + (( _floatToStringWitRaz(((( (analogRead (5)))*(0.0049))/(0.017))+(_dht1t),2)))))).length();
if (_disp1oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp1oldLength = _dispTempLength1;
_lcd1.setCursor(0, 1);
_lcd1.print((((String("T ")) + (( _floatToStringWitRaz(((( (analogRead (5)))*(0.0049))/(0.017))+(_dht1t),2))))));
} else {
if (_disp1oldLength > 0) {_isNeedClearDisp1 = 1; _disp1oldLength = 0;} 
}




}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }
String  _floatToStringWitRaz(float value, int raz)
{
  float tv;
  int ti = int(value);
  String ts = String(ti);
  if (raz == 0) {
    return ts;
  }
  ts += ".";
  float tf = abs(value - ti);
  for (int i = 1; i <= raz; i++ )
  {
    tv = tf * 10;
    ti = int(tv);
    ts += String(ti);
    tf = (tv - ti);
  }
  return ts;
}
